#!/usr/bin/perl -w
# TODO gerer l'ordre des 
#     - managements
#     - 
#     - documentaires
use strict;

use locale;

use FindBin;
use lib "$FindBin::Bin/../lib";

use DBI qw(:sql_types);
use DBD::ODBC;
use XML::WordML::SimpleWriter;
use Data::Dumper;
use Text::Template;
use File::Copy;
use FindBin;
use Data::Dumper;
use Text::Wrapper;
#use Date::Language;
use Number::Format qw(:subs :vars);
#use Unicode::String qw(utf8 latin1 utf16);

#Date::Format->language('French');

#use Date::Language::French;
           

$THOUSANDS_SEP   = ' ';
$DECIMAL_POINT   = ',';
$INT_CURR_SYMBOL = '';
  
my $OUTPUTROOT_PATH   = "$FindBin::Bin/../output";
my $TEMPLATE_PATH     = "$FindBin::Bin/../template";
my $DB_PATH           = "$FindBin::Bin\\..";

my @lt = localtime;
my $OUTPUT_FNAME   = $OUTPUTROOT_PATH.'/'.sprintf('%04u%02u%02u-%02u%02u-%02u', 
                      $lt[5]+1900, $lt[4]+1, $lt[3], $lt[2], $lt[1], $lt[0] )
                      .".xml";
                    #$OUTPUTROOT_PATH.'/test';


my $DBFILE    = "$DB_PATH\\base_de_saisie2005.mdb";
my $DBUSER    = "dummy";
my $DBPASS    = "dummy";


my $TMPL_CARD = "$TEMPLATE_PATH/word/fiche.xml";

my %REPLACEMENTS = (
    '&'                   => '&amp;',
    '>'                   => '&gt;',
    '<'                   => '&lt;',
    '\x92'                => "'",
    # 'é'                   => '',
    # 'è'                   => '',
    # 'à'                   => '&agrave;',
);

my $SQL_CHANNEL=<<SQLEOF;
SELECT id, 
       answerer, 
       last_updated, 
       channel, editor, 
       date_creation, date_lancement,
       status, 
       capital, 
       shareholders, 
       participations, 
       employees, 
       thema, 
       concept, 
       address, 
       tel, 
       fax, web, 
       subscr_total, 
       subscr_cable, 
       subscr_sat, 
       geo_coverage, 
       satellites, 
       sat_canalsat_basic, sat_canalsat_option, sat_canalsat_nc,
       sat_tps_basic,      sat_tps_option,      sat_tps_nc,
       sat_other, 
       cable_noos_basic_anal,          cable_noos_option_anal,          cable_noos_basic_num,          cable_noos_option_num, 
       cable_noos_nc,
       cable_upc_basic_anal,           cable_upc_option_anal,           cable_upc_basic_num,           cable_upc_option_num, 
       cable_upc_nc,
       cable_ncnumericable_basic_anal, cable_ncnumericable_option_anal, cable_ncnumericable_basic_num, cable_ncnumericable_option_num, 
       cable_ncnumericable_nc,
       cable_ftc_basic_anal,           cable_ftc_option_anal,           cable_ftc_basic_num,           cable_ftc_option_num, 
       cable_ftc_nc,
       cable_other_basic_anal,         cable_other_option_anal,         cable_other_basic_num,         cable_other_option_num, 
       broadcast_week_begin,           broadcast_week_end,              broadcast_we_begin,            broadcast_we_end, 
       annual_programs_volume,         annual_new_programs,             annual_coproduced_programs,    annual_produced_programs, 
       annual_brought_programs,        progs_pct_cinema,                progs_pct_cartoon,             progs_pct_doc, 
       progs_pct_fiction,              progs_pct_news,                  progs_pct_games,               progs_pct_mag,
       progs_pct_show,                 progs_pct_sport,                 progs_pct_sale_services,       progs_pct_music,   
       regie_adv_name,                 regie_adv_manager,               regie_adv_address,             regie_adv_tel, 
       regie_adv_fax,                  regie_adv_web,                   
       ca_pct_subscr,                  ca_pct_advert,                   ca_pct_other, 
       awards,                    
       div_interaction_coord,          div_interaction_editor,          div_web_coord,                 div_web_editor, 
       div_sms_coord,                  div_sms_editor,                  div_audiotel_coord,            div_audiotel_editor, 
       div_minitel_coord,              div_minitel_editor,              div_other_coord,               div_other_editor       
FROM channels
ORDER BY channel
SQLEOF

###################### Utility functions for template
my $rowclass='';

sub isFilled($) { my $v = shift; return ( defined($v) and !($v =~ m/^\s*$/g) ) }

sub normalize($) 
{
   my ($text) = shift;
   
   return '' if( !defined($text) or ($text eq '') ) ;
   
   $text =~ s/<CR\s*>/\n /g;
   
   foreach my $old ( sort keys %REPLACEMENTS )  {
      my $new = $REPLACEMENTS{$old};
      $text =~ s/$old/$new/g;
   }
   
   
   #empty lines cleanup
   $text =~ s/^\n//g;
   my @lines = split(/\n/,$text);
   if( scalar(@lines) >1 ) {
      $text='';
      foreach my $line ( @lines ) {
         next if($line =~ m/^\s*$/g );
         chomp($line);
         $text .= "$line\n";
      }
   }
   #$text =~ s/\&/&amp;/g; $text =~ s/>/&gt;/g; $text =~ s/</&lt;/g; $text =~ s/\x92/'/g;
   #my $uni = latin1($text);
   #$text =$uni->utf8;
   return undef if( $text =~ /^\s*$/g) ;
   return $text;
}#eo normalize

sub item {
     my ($wml,$lvl,$title,$val,$unit) = @_;
     
     if( isFilled($val) ) {
        $unit = '' if (!defined($unit) );
        $wml->begin_listitem($lvl);
        $wml->append("$title : ");
        appendField($wml,$val);
        $wml->append(" $unit ");
        $wml->end_listitem();
        return 1;
     } else {
        return undef;
     }
}#eo item

sub itemBreak {
     my ($wml,$lvl,$title,$val,$unit) = @_;
     
     if( isFilled($val) ) {
        $unit = '' if (!defined($unit) );
        $wml->begin_listitem($lvl);
        $wml->append("$title : ");
        parag_break($wml,$val);
        $wml->append(" $unit ");
        $wml->end_listitem();
        return 1;
     } else {
        return undef;
     }
}#eo item



sub item2($$$$$$) {
     my ($wml,$lvl,$title,$val,$title2,$val2) = @_;
     
        
     if( isFilled($val) ) {
             $wml->begin_listitem($lvl);
             $wml->append("$title ");
             appendField($wml,$val);
             $wml->append(" $title2 ");
             appendField($wml,$val2); 
            $wml->end_listitem();
            return 1;
     } else {
             return undef;
     }
}#eo item2

sub nformat($)
{
   my ($val) = @_;
   return format_number($val,2);
}#eo nformat

sub itemInt 
{
     my ($wml,$lvl,$title,$val,$unit,$digits) = @_;
     $digits = 2 unless defined $digits;
     if( isFilled($val) ) {
        $unit = '' if (!defined $unit);
        $val = format_number($val,$digits);
        $wml->begin_listitem($lvl);
        $wml->append("$title : ");
        appendField($wml,$val);
        $wml->append(" $unit ");
        $wml->end_listitem();
        return 1;
     } else {
        return undef;
     }
}#eo itemint


sub toUrl($) {
   my ($url) = @_;
   if( $url =~ m/\@/ and !($url =~ /^mailto:/) ) {
      $url = "mailto:$url";
   } elsif( !($url =~ /^http:/) ) {
      $url = "http://$url";
   }
   return $url;
}

sub insider_arrayRow {
   my ($nbcols, $rowclass, @cols )= @_;
   
   if( !defined($rowclass) or $rowclass eq '' ) { 
      $rowclass = ' class="hi" '; 
   } else { $rowclass = ''; }

   #print "$rrowclass>>>>>[$rowclass]\n";

   my $txt = "<w:tr $rowclass>";
   for( my $i=0; $i < $nbcols; $i++) {
      $txt .= " <w:tc><w:p><w:r>";
      if( isFilled( $cols[$i] ) ) {
         $txt .= $cols[$i];
      } else {
         $txt .= 'N.C.';
      }
      $txt .= "</w:r></w:p></w:tc>\n";
   }
   $txt .= "</w:tr>\n";
   
   
   return $txt;
}

#######################################################

#sub import_vars($)
#{
#       my ($rVars) = $_;
#       foreach my $var ( keys %$rVars ){
#               *{$var} = $rVars->{$var};
#       }
#}#eo import vars



sub dbconnect($$$) 
{
   my ($file,$user,$pass) = @_;
   my $dsn     = "driver=Microsoft Access Driver (*.mdb);dbq=$file";
   my $db_str  = "dbi:ODBC:$dsn";

   my $dbh = DBI->connect($db_str, $user, $pass) 
         or die "Connection error: $DBI::errstr\n";
   $dbh->{LongReadLen} = 32768; #setting a large buffer
   return $dbh
}

sub dbselect($$) 
{
   my ($dbh,$sql) = @_;
   $sql =~ s/\s+/ /g;
   my $rh = $dbh->prepare($sql) or die "error while preparing '$sql' : $DBI::errstr";
   $rh->execute() or die "error while executing '$sql' : $DBI::errstr";
   return $rh;
}

sub writeToFile($$)
{
    my ($fname,$content) = @_;
    open( FOUT, ">$fname" ) or die "could not open $fname for output: $!";
    print FOUT $content;
    close FOUT;
}

# supress leading and 
# tailing spaces
sub trim($) 
{
   my ($str) = @_;
   return if !defined($str);
   $str =~ s/^\s+//g;
   $str =~ s/\s+$//g;
   return $str;
}

sub appendField($$)
{
        my ($wml,$val) = @_;
        $wml->append($val,"i");
}#eo appendField

sub cablenetwork_val
{           
   my ( $nc,  $anal, $num) = @_; 
   my $val;
   if( $nc ) { $val = 'N.C.'; } 
   elsif ( $anal and $num ) { $val =  "Analogique / Numerique;"}
   elsif ( $anal)           { $val =  "Analogique";            }
   elsif ( $num)            { $val =  "Numerique";             }
   else  { $val = "Non" }  
   return $val;
}#eo cablenetwork_val

sub cablenetwork_other_val
{
     my ( $num, $anal) = @_; 

     if( defined($num ) and ($num  =~ m/\s*x\s*$/i ) ){
                $num='Numrique';
     } elsif( isFilled($num) ) {
                $num="Numrique ($num)";                        
     } else {    
                $num='';
     }
                    
     if( defined($anal) and ($anal =~ m/^\s*x\s*$/i ) ) {
                $anal='Analogique'; 
     } elsif( isFilled($anal) ) {
                $anal="Analogique ($anal)";                     
     } else {
                $anal=''; 
     }
                    
    # Wrapping
    my $res=undef;
    if(  ( $anal ne '' ) and  ( $num ne '' ) ) {
        $res = "$anal / $num"; 
    } elsif ( ( $anal eq '' ) and  ( $num eq '' ) ) {
        $res = "Non";                     
    } else { 
        $res = "$anal$num"; 
    }
    return $res;
        
}#eo cablenetwork_other_val

sub parag_break($$)
{
    my ($wml,$txt) = @_;
    my @lines = split(/\n/,normalize( $txt ));
    foreach my $line (@lines) {
        $wml->append_parag("Normal",$line);
    }
}#eo parag_break


sub generateChannelPage($$$) 
{
   my ($dbh,$rInf,$wml) = @_;
   
   # Query secondary tables :
   my $chan_id = normalize( $rInf->{'id'} );

   my $sql = <<SQLEOF;
   SELECT id, name, coproducer, prog_type
   FROM programs_stock
   WHERE channel = $chan_id
SQLEOF
   my $rh = dbselect($dbh,$sql);
   my @stock_programs;
   my @row;
   while( @row = $rh->fetchrow() ) {
      push(@stock_programs,[  $row[1], $row[2], $row[3] ]);
   }
   $rh->finish();

   my @stream_programs;
   $sql = <<SQLEOF;                     
SELECT id, name, producer, programmation
FROM programs_stream
WHERE channel = $chan_id
SQLEOF
   $rh = dbselect($dbh,$sql);
   while( @row = $rh->fetchrow() ) {
      push(@stream_programs,[  $row[1], $row[2], $row[3] ]);
   }
   $rh->finish();

   my @management;
   $sql = <<SQLEOF;
SELECT management.id, management.title, management.descr
FROM  management_order INNER JOIN management 
        ON management_order.title = management.title
WHERE management.channel = $chan_id
ORDER BY management_order.ordre
SQLEOF
   $rh = dbselect($dbh,$sql);
   while( @row = $rh->fetchrow() ) {
      push(@management,[ $row[1], $row[2] ]);
   }
   $rh->finish();


   my @budget;
   $sql = <<SQLEOF;
SELECT year, total, gross_rating_point, marketing, program_purchase, program_production, program_coproduction
FROM channel_budget
WHERE channel = $chan_id
ORDER BY year;
SQLEOF
   $rh = dbselect($dbh,$sql);
   while( @row = $rh->fetchrow() ) {
      push(@budget,[ $row[0], $row[1], $row[2], $row[3], $row[4], $row[5], $row[6] ]);
   }
   $rh->finish();


   #generating the page
   ##################################################################################################################
   $wml->begin_subsection();
           $wml->append_heading(2,"\&gt; ".normalize( $rInf->{'channel'}) );

           parag_break($wml,  normalize( $rInf->{'address'}) );
           if( isFilled( $rInf->{'tel'})  ) {
		   my $tel = normalize( $rInf->{'tel'} );
		   $tel =~ s/[\.\-]/ /g;
                   $wml->begin_parag('Address');
                   $wml->append("Tel :","u");
                   $wml->append(  " $tel" );
           }               
           $wml->end_parag();
           if( isFilled( $rInf->{'fax'}) ) {
		   my $fax = normalize( $rInf->{'fax'});
		   $fax =~ s/[\.\-]/ /g;
                   $wml->begin_parag('Address');
                   $wml->append("Fax :","u");
                   $wml->append( " $fax"  );
           }               
           $wml->end_parag();
           if( isFilled( $rInf->{'web'}) ) {
		   my $web = toUrl(normalize( $rInf->{'web'}));
                   $wml->begin_parag('Address');
                   $wml->append("Web :","u");
                   $wml->append( " $web" );
           }               
           $wml->end_parag();
            
           $wml->begin_subsection();
                $wml->append_heading(3, "Socit ditrice : ".normalize( $rInf->{'editor'}) );
                    item($wml,1,"Date de cration",normalize( $rInf->{'date_creation'}));          
                    item($wml,1,"Date de lancement",normalize( $rInf->{'date_lancement'}));        
                    item($wml,1,"Forme juridique", normalize( $rInf->{'status'}));                 
                    itemInt($wml,1,"Montant du capital",normalize( $rInf->{'capital'}),'euro');  
                    item($wml,1,"Principaux actionnaires",normalize( $rInf->{'shareholders'}));   
                    item($wml,1,"Participations",normalize( $rInf->{'participations'}));                
                    itemInt($wml,1,"Effectifs",normalize( $rInf->{'employees'}),'personnes');     
                    item($wml,1,"Thmatique",normalize( $rInf->{'thema'})); 		    
                    itemBreak($wml,1,"Concept / positionnement",normalize( $rInf->{'concept'})); 
                    foreach my $r (@management) {
                            my ($title,$descr) = @$r;
                            next if( !isFilled( $title ) or !isFilled( $descr ) );
                                    item($wml, 1, normalize($title), normalize($descr));
				    
                    }
           $wml->end_subsection();
	   if( isFilled($rInf->{'subscr_total'}) ) {
           	$wml->begin_subsection();
	   		my $abo=format_number(normalize($rInf->{'subscr_total'}),0);
	                $wml->append_heading(3, "Nombre total d'abonns $abo abonns");
        	        itemInt($wml,1,"Dont cble ", normalize( $rInf->{'subscr_cable'}), 'abonns',0);         
                	itemInt($wml,1,"Dont satellite",    normalize( $rInf->{'subscr_sat'}),'abonns',0);           
	                itemBreak($wml,1,   "Zones couvertes", normalize( $rInf->{'geo_coverage'}));           
        	        item($wml,1,   "Satellite(s) de diffusion", normalize( $rInf->{'satellites'}));      
	           $wml->end_subsection();
   	   }
           $wml->begin_subsection();
                $wml->append_heading(3,"Bouquets satellite :");
                my $canalsat = ""; 
                if( normalize( $rInf->{'sat_canalsat_nc'}) ) {
                        $canalsat = 'N.C.';
                } else {
                    $canalsat  = "Basique "  if( normalize( $rInf->{'sat_canalsat_basic'}) );
                    if( normalize( $rInf->{'sat_canalsat_option'}) ) {
                       $canalsat .= " et " if( defined($canalsat) and $canalsat ne '' );
                       $canalsat .="Option";  
                    }
                    $canalsat = 'non' if( !defined($canalsat) or ($canalsat eq '') );
                }
                item($wml,1,"CanalSatellite ", $canalsat);        

                my $tps = "";
                if( normalize( $rInf->{'sat_tps_nc'}) ) {
                    $tps = 'N.C.';
                } else {
                    $tps  = "Basique" if( normalize( $rInf->{'sat_tps_basic'})   );
                    if( normalize( $rInf->{'sat_tps_option'} ) ) {
                        $tps .= " et " if( defined($tps) and $tps ne '' );
                        $tps .= "Option";           
                    }
                    $tps = 'non' if( !defined($tps) or ($tps eq '') );
                }
                item($wml,1,"TPS ", $tps);                     
                item($wml,1,"Autre ", normalize( $rInf->{'sat_other'}));   
            $wml->end_subsection();
            
            my $noos_basic  = cablenetwork_val( normalize( $rInf->{'cable_noos_nc'}), 
                                                normalize( $rInf->{'cable_noos_basic_anal'}),  
						normalize( $rInf->{'cable_noos_basic_num'}));
            my $noos_option = cablenetwork_val( normalize( $rInf->{'cable_noos_nc'}), 
                                                normalize( $rInf->{'cable_noos_option_anal'}), 
						normalize( $rInf->{'cable_noos_option_num'}));
            my $upc_basic   = cablenetwork_val( normalize( $rInf->{'cable_upc_nc'}),  
                                                normalize( $rInf->{'cable_upc_basic_anal'}),   
						normalize( $rInf->{'cable_upc_basic_num'}));
            my $upc_option  = cablenetwork_val( normalize( $rInf->{'cable_upc_nc'}),  
                                                normalize( $rInf->{'cable_upc_option_anal'}),  
						normalize( $rInf->{'cable_upc_option_num'}));
            my $ftc_basic   = cablenetwork_val( normalize( $rInf->{'cable_ftc_nc'}),  
                                                normalize( $rInf->{'cable_ftc_basic_anal'}),   
						normalize( $rInf->{'cable_ftc_basic_num'}));
            my $ftc_option  = cablenetwork_val( normalize( $rInf->{'cable_ftc_nc'}),  
                                                normalize( $rInf->{'cable_ftc_option_anal'}),  
						normalize( $rInf->{'cable_ftc_option_num'}));
            my $ncn_basic   = cablenetwork_val( normalize( $rInf->{'cable_ncnumericable_nc'}), 
                                                normalize( $rInf->{'cable_ncnumericable_basic_anal'}), 
                                                normalize( $rInf->{'cable_ncnumericable_basic_num'}));
            my $ncn_option  = cablenetwork_val( normalize( $rInf->{'cable_ncnumericable_nc'}), 
                                                normalize( $rInf->{'cable_ncnumericable_option_anal'}), 
                                                normalize( $rInf->{'cable_ncnumericable_option_num'}));
            
            my $other_basic = cablenetwork_other_val( normalize( $rInf->{'cable_other_basic_num'}),  
						      normalize( $rInf->{'cable_other_basic_anal'}) );
            my $other_option= cablenetwork_other_val( normalize( $rInf->{'cable_other_option_num'}), 
		    				      normalize( $rInf->{'cable_other_option_anal'}) );
            
            $wml->begin_subsection();
                $wml->append_heading(3,"Rseaux cbls :");
                $wml->begin_table('StdTable');
                        $wml->begin_tablerow('head');
                                $wml->append_tablecell("Rseau");
                                $wml->append_tablecell("Basique");
                                $wml->append_tablecell("Option");
                        $wml->end_tablerow();
                        $wml->begin_tablerow();
                                $wml->append_styled_tablecell("Noos",'b');
                                $wml->append_tablecell($noos_basic);
                                $wml->append_tablecell($noos_option);                           
                        $wml->end_tablerow();
                        $wml->begin_tablerow();
                                $wml->append_styled_tablecell("UPC",'b');
                                $wml->append_tablecell($upc_basic);
                                $wml->append_tablecell($upc_option);                            
                        $wml->end_tablerow();
                        $wml->begin_tablerow();
                                $wml->append_styled_tablecell("NC Numricable",'b');
                                $wml->append_tablecell($ncn_basic);
                                $wml->append_tablecell($ncn_option);                            
                        $wml->end_tablerow();
                        $wml->begin_tablerow();                 
                                $wml->append_styled_tablecell("FTC",'b');
                                $wml->append_tablecell($ftc_basic);
                                $wml->append_tablecell($ftc_option);                            
                        $wml->end_tablerow();                           
                        $wml->begin_tablerow();
                                $wml->append_styled_tablecell("Autres oprateurs",'b');
                                $wml->append_tablecell($other_basic);
                                $wml->append_tablecell($other_option);
                        $wml->end_tablerow();
                $wml->end_table();
         $wml->end_subsection();

         
         $rInf->{'broadcast_week_begin'} = substr(normalize( $rInf->{'broadcast_week_begin'}),10,6) if( isFilled( $rInf->{'broadcast_week_begin'}) ) ;
         $rInf->{'broadcast_week_end'}   = substr(normalize( $rInf->{'broadcast_week_end'}),10,6)   if( isFilled( $rInf->{'broadcast_week_end'}) ) ;
         $rInf->{'broadcast_we_begin'}   = substr(normalize( $rInf->{'broadcast_we_begin'}),10,6)   if( isFilled( $rInf->{'broadcast_we_begin'}) ) ;
         $rInf->{'broadcast_we_end'}     = substr(normalize( $rInf->{'broadcast_we_end'}),10,6)     if( isFilled( $rInf->{'broadcast_we_end'}) ) ;
         if( 
                 isFilled( $rInf->{'broadcast_week_begin'}) and isFilled( $rInf->{'broadcast_week_end'}) 
              or (isFilled(  $rInf->{'broadcast_we_begin'} )  and isFilled(  $rInf->{'broadcast_we_end'}) )
         ) {
             $wml->begin_subsection();
                 $wml->append_heading(3,"Horaires de diffusion : ");
                 item2($wml,1, "Semaine de ",    $rInf->{'broadcast_week_begin'}, "  ", $rInf->{'broadcast_week_end'});                 
                 item2($wml,1, "Week End de ",   $rInf->{'broadcast_we_begin'},   "  ",   $rInf->{'broadcast_we_end'} );      
             $wml->end_subsection();
         }

        $wml->begin_subsection();
		my $diff = "";
		$diff = format_number( normalize( $rInf->{'annual_programs_volume'}), 0)." heure"
	       		if defined( $rInf->{'annual_programs_volume'} ); 
		$wml->append_heading(3,"Volume annuel de programmes diffuss : $diff");
                itemInt($wml,1,"Volume annuel de programmes indits diffuss", normalize( $rInf->{'annual_new_programs'}),       'heures');           
                itemInt($wml,1,"Volume annuel de programmes coproduits",       normalize( $rInf->{'annual_coproduced_programs'}),'heures');    
                itemInt($wml,1,"Volume annuel de productions propres",         normalize( $rInf->{'annual_produced_programs'}),  'heures');      
                itemInt($wml,1,"Volume annuel de programmes achets",          normalize( $rInf->{'annual_brought_programs'}),   'heures');            $wml->append_parag(" "); 
        $wml->end_subsection();
        
           
        $wml->begin_subsection();
                $wml->append_heading(3,"Part des diffrents genres de programme : ");
		if( isFilled($rInf->{'progs_pct_cinema'}) ) {
			my $cine = normalize($rInf->{'progs_pct_cinema'});
	                itemInt ($wml,1,"Cinma" , $cine,'%')
		       		if $cine!=0;                        
		}
		if( isFilled($rInf->{'progs_pct_cartoon'}) ) {
			my $cartoon = normalize( $rInf->{'progs_pct_cartoon'});
			itemInt ($wml,1,"Dessin Anim" , $cartoon,'%') 
				if $cartoon!=0;                 
		}
		if( isFilled($rInf->{'progs_pct_doc'}) ) {
			my $docu = normalize( $rInf->{'progs_pct_doc'});
	                itemInt ($wml,1,"Documentaires" ,$docu ,'%') 
				if $docu!=0;     
		}
 		if( isFilled( $rInf->{'progs_pct_fiction'} ) ) {
			my $fiction = normalize( $rInf->{'progs_pct_fiction'} );
                	itemInt ($wml,1,"Fiction" ,$fiction ,'%') 
				if $fiction!=0;      
		}
		if( isFilled(	$rInf->{'progs_pct_news'} ) ) {
			my $news = normalize( $rInf->{'progs_pct_news'} );
			itemInt ($wml,1,"Information" , $news,'%') 
				if $news!=0;      
		}
 		if( isFilled($rInf->{'progs_pct_games'} ) ) {
			my $games = normalize( $rInf->{'progs_pct_games'} );	
	                itemInt ($wml,1,"Jeux" , $games,'%') 
				if $games!=0;      
		}
		if( isFilled( $rInf->{'progs_pct_mag'} ) ) {
			my $mag = normalize( $rInf->{'progs_pct_mag'});
                	itemInt ($wml,1,"Magazines, Talk Show" ,$mag ,'%') 
				if $mag!=0;  
		}
      		if( isFilled( $rInf->{'progs_pct_show'} ) ) {
			my $show = normalize( $rInf->{'progs_pct_show'} );
        	        itemInt ($wml,1,"Spectacles" ,$show ,'%') 
				if $show!=0;     
		}
		if( isFilled( $rInf->{'progs_pct_sport'} ) ) {
			my $sport = normalize( $rInf->{'progs_pct_sport'}) ;
                	itemInt ($wml,1,"Sport" ,$sport ,'%') 
				if $sport!=0;               
		}
     		if( isFilled( $rInf->{'progs_pct_sale_services'} ) ) {		
			my $teleach = normalize( $rInf->{'progs_pct_sale_services'});
        	        itemInt ($wml,1,"Tl-achat &amp; service" , $teleach,'%') 
				if $teleach!=0;   
		}
		if( isFilled(  $rInf->{'progs_pct_music'} ) ) {
			my $div = normalize( $rInf->{'progs_pct_music'});
	                itemInt ($wml,1,"Varits / musique" , $div,'%') 
				if $div!=0;             
		}
        $wml->end_subsection();
        
        if( scalar(@stream_programs) ) {
            $wml->begin_subsection();
                $wml->append_heading(3,"Programmes de flux : ");
                $wml->begin_table('StdTable');
                        $wml->begin_tablerow('head');                   
                                $wml->append_tablecell("Emission de flux");
                                $wml->append_tablecell("Producteur ou co-producteur");
                                $wml->append_tablecell("Crneau de programmation");
                        $wml->end_tablerow();
                        foreach my $prog ( @stream_programs ) {
                           my ($name,$prod,$progra) =  @$prog;
                           next unless( isFilled( $name) );
			   #print "programme : $name\n";
                           $prod = 'N.C.' unless isFilled( $prod );
                           $progra = 'N.C.' unless isFilled( $progra );
                           $wml->begin_tablerow();
                                $wml->append_tablecell(normalize($name));
                                $wml->append_tablecell(normalize($prod));
                                $wml->append_tablecell(normalize($progra));
                           $wml->end_tablerow();
                        }
                $wml->end_table();
            $wml->end_subsection();     
        }
        
        if( scalar(@stock_programs) ) {
            $wml->begin_subsection();
                $wml->append_heading(3,"Programmes de stock : ");
                $wml->begin_table('StdTable');
                        $wml->begin_tablerow('head');                   
                                $wml->append_tablecell("Emission de stock");
                                $wml->append_tablecell("Producteur ou co-producteur");
                                $wml->append_tablecell("Type de programme");
                        $wml->end_tablerow();
                        foreach my $stock ( @stock_programs ) {
                           my ($stname,$coprod,$type) =  @$stock;
                           next unless( isFilled( $stname ) );
                           $coprod = 'N.C.' unless isFilled( $coprod );
                           $type = 'N.C.' unless isFilled( $type );
                           $wml->begin_tablerow();
                                $wml->append_tablecell(normalize($stname));
                                $wml->append_tablecell(normalize($coprod));
                                $wml->append_tablecell(normalize($type));
                           $wml->end_tablerow();
                        }
                $wml->end_table();
            $wml->end_subsection();     
        }
        
        $wml->begin_subsection();
            $wml->append_heading(3,"Rgie publicitaire : ".normalize( $rInf->{'regie_adv_name'}));
	    
            $wml->append_parag("Normal","Responsable / Directeur de clientle : ". normalize( $rInf->{'regie_adv_manager'}))
	   	if isFilled( $rInf->{'regie_adv_manager'} ); 
            parag_break($wml, normalize( $rInf->{'regie_adv_address'} ) )                   
	    	if isFilled( $rInf->{'regie_adv_address'}); 
            $wml->append_parag("Normal","Tel : ".normalize( $rInf->{'regie_adv_tel'}))               
	    	if isFilled( $rInf->{'regie_adv_tel'}) ; 
            $wml->append_parag("Normal","Fax : ".normalize( $rInf->{'regie_adv_fax'}))               
	    	if isFilled( $rInf->{'regie_adv_fax'}) ; 
            $wml->append_parag("Normal", "Internet : ".toUrl(normalize( $rInf->{'regie_adv_web'})) ) 
	    	if isFilled( $rInf->{'regie_adv_web'}) ; 
        $wml->end_subsection(); 
        
        if( isFilled( $rInf->{'awards'}) )  {
            $wml->begin_subsection();
                $wml->append_heading(3,"Rcompenses / distinctions");
                 parag_break($wml, normalize( $rInf->{'awards'}));
            $wml->end_subsection();
        }         
        
  ##################################################################################################################

   $wml->end_subsection();
   print "\tdone.\n";

}#eo processChannel


sub addAlpha($$) 
{
   my ($rIndex,$channel) = @_;
   my $letter = uc(substr($channel,0,1));
   if( !defined( $rIndex->{ $letter } ) ) {
      $rIndex->{ $letter } = { $channel => $channel };
   } else {
      $rIndex->{ $letter }->{$channel} = $channel;   
   }
}#eo addAlpha

sub addThema($$$$) {
   my ($rIndex,$thema, $channel ) =@_;
   $thema = lc($thema);

   if( !defined( $rIndex->{ $thema } ) ) {
      $rIndex->{ $thema } = { $channel => $channel };
   } else {
      $rIndex->{ $thema }->{$channel} = $channel;
   }
}#eo addThema

 sub addRegie($$$) {
   my ($rIndex,$regie_adv_name, $channel) =@_;
   $regie_adv_name = uc($regie_adv_name);

   if( !defined( $rIndex->{ $regie_adv_name } ) ) {
      $rIndex->{ $regie_adv_name } = { $channel => $channel };
   } else {
      $rIndex->{ $regie_adv_name }->{$channel} = $channel;
   }
}#eo addRegie

 sub addEditeur($$$) {
   my ($rIndex,$editeur, $channel) =@_;
   $editeur = lc($editeur);

   if( !defined( $rIndex->{ $editeur } ) ) {
      $rIndex->{ $editeur } = { $channel => $channel };
   } else {
      $rIndex->{ $editeur }->{$channel} = $channel;
   }
}#eo addRegie


sub generateChannels($$) 
{
   my ($dbh,$to) = @_;

   my %alpha_index;
   my %thema_index;
   my %regie_index;
   my %editeur_index;
   my %shareholders_index;

   my $rh   = dbselect($dbh,$SQL_CHANNEL);
   my $tmpl = Text::Template->new( TYPE => 'FILE',  SOURCE =>$TMPL_CARD );
   
   my $wml = new XML::WordML::SimpleWriter;
   $wml->set_encoding('LATIN1');
   $wml->set_defaultFont('Arial');
   $wml->load_stylesheet('style.xml');
   $wml->append_heading(1,"Guide des chaines thmatiques 2005");
   $wml->begin_subsection();
   
   while( my $row = $rh->fetchrow_hashref() ) {
      my $channel    = trim($row->{'channel'});
      my $awards = $row->{'awards'};
      if( defined($awards) ){
         $awards =~s/(\n\r*)+/\n/g;
          #my $wrapper = Text::Wrapper->new(columns => 60, body_start => '  ');
          #$awards= $wrapper->wrap($awards);
          $row->{'awards'} = $awards;
      }

      print "\tprocessing $channel\n";# generating '$page_fname'\n";
      #addAlpha(\%alpha_index, $channel );
      #addThema(\%thema_index, trim($row->{'thema'}), $channel);
      #addRegie(\%regie_index, trim($row->{'regie_adv_name'}) );
      #addEditeur(\%editeur_index, trim($row->{'editor'}), $channel );
      
      generateChannelPage($dbh,$row,$wml); 
   }
   $rh->finish();
   $wml->append_parag(" ");
   $wml->end_subsection();
   writeToFile( $to, $wml->as_string() );

}#eo generateChannels

################################################################""

my $dbh = dbconnect($DBFILE,$DBUSER,$DBPASS);
print "outputing to $OUTPUT_FNAME\n";
generateChannels($dbh,$OUTPUT_FNAME);
$dbh->disconnect();

__END__
